Index: palm/trunk/SCRIPTS/inifor_script
===================================================================
--- palm/trunk/SCRIPTS/inifor_script	(revision 3791)
+++ palm/trunk/SCRIPTS/inifor_script	(revision 3792)
@@ -22,9 +22,12 @@
 # Current revisions:
 # ------------------
-# initial revision
+# 
 # 
 # Former revisions:
 # -----------------
 # $Id$
+# initial revision
+# 
+# 
 # 
 #--------------------------------------------------------------------------------#
Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3791)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3792)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! Interpolations improved. Large number of obsolete subroutines removed.
+! All unused variables removed. 
+! 
+! 3741 2019-02-13 16:24:49Z hellstea
 ! Interpolations and child initialization adjusted to handle set ups with child 
 ! pe-subdomain dimension not integer divisible by the grid-spacing ratio in the 
@@ -448,4 +452,6 @@
     INTEGER(iwp), PARAMETER ::  child_to_parent = 2   !<
     INTEGER(iwp), PARAMETER ::  parent_to_child = 1   !<
+    INTEGER(iwp), PARAMETER ::  interpolation_scheme_lrsn = 2  !< Interpolation scheme to be used on lateral boundaries (to be made user parameter)
+    INTEGER(iwp), PARAMETER ::  interpolation_scheme_t    = 3  !< Interpolation scheme to be used on top boundary (to be made user parameter)
 !
 !-- Coupler setup
@@ -457,18 +463,9 @@
 !
 !-- Control parameters
-    CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !< steering
-                                                         !< parameter for data-
-                                                         !< transfer mode
-    CHARACTER(LEN=8), SAVE ::  nesting_mode = 'two-way'  !< steering parameter
-                                                         !< for 1- or 2-way nesting
+    CHARACTER(LEN=7), SAVE ::  nesting_datatransfer_mode = 'mixed'  !< steering parameter for data-transfer mode
+    CHARACTER(LEN=8), SAVE ::  nesting_mode = 'two-way'             !< steering parameter for 1- or 2-way nesting
 
     LOGICAL, SAVE ::  nested_run = .FALSE.  !< general switch
     LOGICAL       ::  rans_mode_parent = .FALSE. !< mode of parent model (.F. - LES mode, .T. - RANS mode)
-
-    REAL(wp), SAVE ::  anterp_relax_length_l = -1.0_wp   !<
-    REAL(wp), SAVE ::  anterp_relax_length_r = -1.0_wp   !<
-    REAL(wp), SAVE ::  anterp_relax_length_s = -1.0_wp   !<
-    REAL(wp), SAVE ::  anterp_relax_length_n = -1.0_wp   !<
-    REAL(wp), SAVE ::  anterp_relax_length_t = -1.0_wp   !<
 !
 !-- Geometry
@@ -477,5 +474,4 @@
     REAL(wp), SAVE, PUBLIC                            ::  lower_left_coord_x !<
     REAL(wp), SAVE, PUBLIC                            ::  lower_left_coord_y !<
-
 !
 !-- Children's parent-grid arrays
@@ -484,105 +480,29 @@
     INTEGER(iwp), SAVE, DIMENSION(4), PUBLIC    ::  coarse_bound_w      !< subdomain index bounds for children's parent-grid work arrays
 
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  dissc !< coarse grid array on child domain - dissipation rate
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ec   !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ptc  !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  uc   !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vc   !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wc   !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_c  !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qcc  !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qrc  !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nrc  !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ncc  !<
-    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sc   !<
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  dissc !< Parent-grid array on child domain - dissipation rate
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ec    !< Parent-grid array on child domain - SGS TKE
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ptc   !< Parent-grid array on child domain - potential temperature
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  uc    !< Parent-grid array on child domain - velocity component u
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  vc    !< Parent-grid array on child domain - velocity component v
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  wc    !< Parent-grid array on child domain - velocity component w
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  q_c   !< Parent-grid array on child domain - 
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qcc   !< Parent-grid array on child domain - 
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  qrc   !< Parent-grid array on child domain - 
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  nrc   !< Parent-grid array on child domain - 
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  ncc   !< Parent-grid array on child domain - 
+    REAL(wp), SAVE, DIMENSION(:,:,:), ALLOCATABLE, TARGET ::  sc    !< Parent-grid array on child domain - 
     INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  nr_partc    !<
     INTEGER(idp), SAVE, DIMENSION(:,:), ALLOCATABLE, TARGET, PUBLIC ::  part_adrc   !<
 
-    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c !< coarse grid array on child domain - chemical species
-
-!
-!-- Child interpolation coefficients and child-array indices to be 
-!-- precomputed and stored.
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  ico    !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  icu    !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jco    !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  jcv    !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kco    !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:) ::  kcw    !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  celltmpd !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xo   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xo   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1xu   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2xu   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yo   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yo   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1yv   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2yv   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zo   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zo   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r1zw   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:)     ::  r2zw   !<
-
-!
-!-- Child index arrays and log-ratio arrays for the log-law near-wall
-!-- corrections. These are not truly 3-D arrays but multiple 2-D arrays.
-    INTEGER(iwp), SAVE :: ncorr  !< 4th dimension of the log_ratio-arrays
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_l   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_n   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_r   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_u_s   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_l   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_n   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_r   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_v_s   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_l   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_n   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_r   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  logc_w_s   !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_u_l !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_u_n !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_u_r !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_u_s !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_v_l !<    
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_v_n !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_v_r !<    
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_v_s !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_w_l !<    
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_w_n !<
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_w_r !<    
-    INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:)   ::  logc_kbounds_w_s !<        
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_l   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_n   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_r   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_u_s   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_l   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_n   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_r   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_v_s   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_l   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_n   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_r   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:,:,:,:)   ::  logc_ratio_w_s   !<
-!
+    REAL(wp), SAVE, DIMENSION(:,:,:,:), ALLOCATABLE, TARGET ::  chem_spec_c !< Parent-grid array on child domain - chemical species
+!
+!-- Grid-spacing ratios.
     INTEGER(iwp), SAVE ::  igsr     !< Integer grid-spacing ratio in i-direction 
     INTEGER(iwp), SAVE ::  jgsr     !< Integer grid-spacing ratio in j-direction 
     INTEGER(iwp), SAVE ::  kgsr     !< Integer grid-spacing ratio in k-direction 
+!
+!-- Highest prognostic parent-grid k-indices.
     INTEGER(iwp), SAVE ::  kcto     !< Upper bound for k in anterpolation of variables other than w.
     INTEGER(iwp), SAVE ::  kctw     !< Upper bound for k in anterpolation of w.
-    INTEGER(iwp), SAVE ::  nxlfc    !< Lower index limit in x-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
-    INTEGER(iwp), SAVE ::  nxrfc    !< Upper index limit in x-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
-    INTEGER(iwp), SAVE ::  nynfc    !< Upper index limit in y-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
-    INTEGER(iwp), SAVE ::  nysfc    !< Lower index limit in y-direction for fine-to-coarse index mapping and interpolaton coefficient arrays
-!
-!-- Upper bound for k in log-law correction in interpolation.
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_l   !<
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_n   !<
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_r   !<
-    INTEGER(iwp), SAVE ::  nzt_topo_nestbc_s   !<
-!
-!-- Spatial under-relaxation coefficients for anterpolation.
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  frax   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fray   !<
-    REAL(wp), SAVE, ALLOCATABLE, DIMENSION(:) ::  fraz   !<
 !
 !-- Child-array indices to be precomputed and stored for anterpolation.
@@ -606,5 +526,14 @@
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_w  !< number of child grid boxes contribution to a parent grid box, w-grid
     INTEGER(iwp), SAVE, ALLOCATABLE, DIMENSION(:,:,:) ::  ijkfc_s  !< number of child grid boxes contribution to a parent grid box, scalar-grid
-    
+!    
+!-- Work arrays for interpolation and user-defined type definitions for horizontal work-array exchange    
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_lr
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_sn
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_t
+    INTEGER(iwp) :: workarrc_lr_exchange_type
+    INTEGER(iwp) :: workarrc_sn_exchange_type
+    INTEGER(iwp) :: workarrc_t_exchange_type_x
+    INTEGER(iwp) :: workarrc_t_exchange_type_y
+ 
     INTEGER(iwp), DIMENSION(3)          ::  parent_grid_info_int    !<
     REAL(wp), DIMENSION(7)              ::  parent_grid_info_real   !<
@@ -652,17 +581,5 @@
     INTEGER(idp),ALLOCATABLE,DIMENSION(:,:),PUBLIC,TARGET    :: part_adr !<
 
-!AH 
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_lr
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_sn
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarr_t
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_lr
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_sn
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: workarrc_t
-    INTEGER(iwp) :: workarrc_lr_exchange_type
-    INTEGER(iwp) :: workarrc_sn_exchange_type
-    INTEGER(iwp) :: workarrc_t_exchange_type_x
-    INTEGER(iwp) :: workarrc_t_exchange_type_y
-!AH
-    
+   
     INTERFACE pmci_boundary_conds
        MODULE PROCEDURE pmci_boundary_conds
@@ -713,14 +630,10 @@
     END  INTERFACE get_child_gridspacing
 
-
     INTERFACE pmci_set_swaplevel
        MODULE PROCEDURE pmci_set_swaplevel
     END INTERFACE pmci_set_swaplevel
 
-    PUBLIC anterp_relax_length_l, anterp_relax_length_r,                       &
-           anterp_relax_length_s, anterp_relax_length_n,                       &
-           anterp_relax_length_t, child_to_parent, comm_world_nesting,         &
-           cpl_id, nested_run, nesting_datatransfer_mode, nesting_mode,        &
-           parent_to_child, rans_mode_parent
+    PUBLIC child_to_parent, comm_world_nesting, cpl_id, nested_run,                                 &
+           nesting_datatransfer_mode, nesting_mode, parent_to_child, rans_mode_parent
 
     PUBLIC pmci_boundary_conds
@@ -733,5 +646,4 @@
     PUBLIC pmci_set_swaplevel
     PUBLIC get_number_of_childs, get_childid, get_child_edges, get_child_gridspacing
-
 
 
@@ -903,7 +815,5 @@
     REAL(wp) ::  xez              !<
     REAL(wp) ::  yez              !<
-
-    REAL(wp), DIMENSION(5) ::  fval             !<
-
+    REAL(wp), DIMENSION(5) ::  fval                      !<
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_x   !<
     REAL(wp), DIMENSION(:), ALLOCATABLE ::  cl_coord_y   !<
@@ -912,5 +822,4 @@
 !   Initialize the pmc parent
     CALL pmc_parentinit
-
 !
 !-- Corners of all children of the present parent
@@ -924,5 +833,4 @@
        ALLOCATE( childgrid(1:SIZE( pmc_parent_for_child ) - 1) )
     ENDIF
-
 !
 !-- Get coordinates from all children
@@ -948,5 +856,7 @@
 !--       transfer
           DO  k = 1, nz                 
-             IF ( zw(k) > fval(1) )  THEN
+!AH  Let's try to make the parent-grid arrays higher by one parent dz 
+!AH             IF ( zw(k) > fval(1) )  THEN
+             IF ( zw(k) > fval(1)+dz(1) )  THEN
                 nz_cl = k
                 EXIT
@@ -954,6 +864,11 @@
           ENDDO
 
-          zmax_coarse = fval(1:2)
-          cl_height   = fval(1)
+!AH  Let's make the parent-grid arrays higher by one parent dz 
+!AH          zmax_coarse = fval(1:2)
+!AH          cl_height   = fval(1)
+          zmax_coarse(1) = fval(1) + dz(1)
+          zmax_coarse(2) = fval(2) + dz(1)
+          cl_height   = fval(1) + dz(1)
+!AH
 
 !    
@@ -1008,5 +923,4 @@
 !--       that the top ghost layer of the child grid does not exceed 
 !--       the parent domain top boundary.
-
           IF ( cl_height > zw(nz) ) THEN
              nomatch = 1
@@ -1092,5 +1006,4 @@
 !--    for coupling are stored once into the pmc context. While data transfer, the array do not
 !--    have to be specified again
-
        CALL pmc_s_clear_next_array_list
        DO  WHILE ( pmc_s_getnextarray( child_id, myname ) )
@@ -1118,5 +1031,5 @@
 
 
-   SUBROUTINE pmci_create_index_list
+    SUBROUTINE pmci_create_index_list
 
        IMPLICIT NONE
@@ -1220,4 +1133,6 @@
      END SUBROUTINE pmci_create_index_list
 
+
+
      SUBROUTINE set_child_edge_coords
         IMPLICIT  NONE
@@ -1254,12 +1169,9 @@
  SUBROUTINE pmci_setup_child
 
-
 #if defined( __parallel )
     IMPLICIT NONE
 
-    CHARACTER(LEN=da_namelen) ::  myname     !<
-
-    INTEGER(iwp) ::  i          !<
-    INTEGER(iwp) ::  ierr       !< 
+    CHARACTER(LEN=da_namelen) ::  myname     !< 
+    INTEGER(iwp) ::  ierr       !< MPI error code
     INTEGER(iwp) ::  icl        !< Left index limit for children's parent-grid arrays
     INTEGER(iwp) ::  icla       !< Left index limit for allocation of index-mapping and other auxiliary arrays
@@ -1268,5 +1180,4 @@
     INTEGER(iwp) ::  icra       !< Right index limit for allocation of index-mapping and other auxiliary arrays
     INTEGER(iwp) ::  icrw       !< Right index limit for children's parent-grid work arrays
-    INTEGER(iwp) ::  j          !< 
     INTEGER(iwp) ::  jcn        !< North index limit for children's parent-grid arrays
     INTEGER(iwp) ::  jcna       !< North index limit for allocation of index-mapping and other auxiliary arrays
@@ -1276,7 +1187,5 @@
     INTEGER(iwp) ::  jcsw       !< South index limit for children's parent-grid work arrays
     INTEGER(iwp) ::  n          !< Running index for number of chemical species
-
     INTEGER(iwp), DIMENSION(5) ::  val        !<
-    
     REAL(wp) ::  xcs        !<
     REAL(wp) ::  xce        !<
@@ -1289,11 +1198,10 @@
 !-- Child setup
 !-- Root model does not have a parent and is not a child, therefore no child setup on root model
-
     IF ( .NOT. pmc_is_rootmodel() )  THEN
 
        CALL pmc_childinit
 !
-!--    Here AND ONLY HERE the arrays are defined, which actualy will be
-!--    exchanged between child and parent.
+!--    The arrays, which actually will be exchanged between child and parent
+!--    are defined Here AND ONLY HERE.
 !--    If a variable is removed, it only has to be removed from here.
 !--    Please check, if the arrays are in the list of POSSIBLE exchange arrays
@@ -1382,22 +1290,9 @@
           CALL pmc_recv_from_parent( rans_mode_parent, 1, 0, 19, ierr )
 !
-!
 !--       Receive Coarse grid information.
           CALL pmc_recv_from_parent( parent_grid_info_real,                    &
                                      SIZE(parent_grid_info_real), 0, 21, ierr )
           CALL pmc_recv_from_parent( parent_grid_info_int,  3, 0, 22, ierr )
-!
-!--        Debug-printouts - keep them
-!           WRITE(0,*) 'Coarse grid from parent '
-!           WRITE(0,*) 'startx_tot    = ',parent_grid_info_real(1)
-!           WRITE(0,*) 'starty_tot    = ',parent_grid_info_real(2)
-!           WRITE(0,*) 'endx_tot      = ',parent_grid_info_real(5)
-!           WRITE(0,*) 'endy_tot      = ',parent_grid_info_real(6)
-!           WRITE(0,*) 'dx            = ',parent_grid_info_real(3)
-!           WRITE(0,*) 'dy            = ',parent_grid_info_real(4)
-!           WRITE(0,*) 'dz            = ',parent_grid_info_real(7)
-!           WRITE(0,*) 'nx_coarse     = ',parent_grid_info_int(1)
-!           WRITE(0,*) 'ny_coarse     = ',parent_grid_info_int(2)
-!           WRITE(0,*) 'nz_coarse     = ',parent_grid_info_int(3)
+
        ENDIF
 
@@ -1416,5 +1311,4 @@
        ALLOCATE( cg%coord_x(-nbgp:cg%nx+nbgp) )
        ALLOCATE( cg%coord_y(-nbgp:cg%ny+nbgp) )
-      
        ALLOCATE( cg%dzu(1:cg%nz+1) )
        ALLOCATE( cg%dzw(1:cg%nz+1) )
@@ -1469,22 +1363,8 @@
        CALL pmc_c_setind_and_allocmem
 !
-!--    Precompute interpolation coefficients and child-array indices
-       CALL pmci_init_interp_tril
-!
-!--    Precompute the log-law correction index- and ratio-arrays 
-       IF ( constant_flux_layer )  THEN
-          CALL pmci_init_loglaw_correction
-       ENDIF
-!
-!--    Two-way coupling for general and vertical nesting.
-!--    Precompute the index arrays and relaxation functions for the
-!--    anterpolation
-!
-!--    Note that the anterpolation index bounds are needed also in case
-!--    of one-way coupling because of the reversibility correction
-!--    included in the interpolation algorithms.
-       CALL pmci_init_anterp_tophat
-!
-!--    Check that the child and parent grid lines match 
+!--    Precompute the index-mapping arrays
+       CALL pmci_define_index_mapping
+!
+!--    Check that the child and parent grid lines do match 
        CALL pmci_check_grid_matching 
 
@@ -1502,5 +1382,4 @@
        INTEGER(iwp), DIMENSION(5,numprocs) ::  coarse_bound_all   !<
        INTEGER(iwp), DIMENSION(2)          ::  size_of_array      !<
-                                   
        INTEGER(iwp) :: i        !< 
        INTEGER(iwp) :: iauxl    !<
@@ -1515,60 +1394,4 @@
        REAL(wp) ::  yexn        !< Parent-grid array exceedance behind the north edge of the child PE subdomain
 
-!AH!
-!AH!--    If the fine- and coarse grid nodes do not match:
-!AH       loffset = MOD( coord_x(nxl), cg%dx )
-!AH       xexl    = cg%dx + loffset
-!AH       xcs  = coord_x(nxl) - xexl
-!AH       DO  i = 0, cg%nx
-!AH          IF ( cg%coord_x(i) > xcs )  THEN
-!AH             icl = MAX( -1, i-1 )
-!AH             EXIT
-!AH          ENDIF
-!AH       ENDDO
-!AH!
-!AH!--    If the fine- and coarse grid nodes do not match
-!AH       roffset = MOD( coord_x(nxr+1), cg%dx )
-!AH       xexr    = cg%dx + roffset
-!AH       xce  = coord_x(nxr+1)
-!AH       IF ( nxr == nx )  THEN
-!AH          xce = xce + xexr
-!AH       ENDIF
-!AH       DO  i = cg%nx, 0 , -1
-!AH          IF ( cg%coord_x(i) < xce )  THEN
-!AH             icr = MIN( cg%nx+1, i+1 )
-!AH             EXIT
-!AH          ENDIF
-!AH       ENDDO
-!AH!
-!AH!--    If the fine- and coarse grid nodes do not match
-!AH       soffset = MOD( coord_y(nys), cg%dy )
-!AH       yexs    = cg%dy + soffset
-!AH       ycs  = coord_y(nys) - yexs
-!AH       DO  j = 0, cg%ny
-!AH          IF ( cg%coord_y(j) > ycs )  THEN
-!AH             jcs = MAX( -nbgp, j-1 )
-!AH             EXIT
-!AH          ENDIF
-!AH       ENDDO
-!AH!
-!AH!--    If the fine- and coarse grid nodes do not match
-!AH       noffset = MOD( coord_y(nyn+1), cg%dy )
-!AH       yexn    = cg%dy + noffset
-!AH       yce  = coord_y(nyn+1)
-!AH       IF ( nyn == ny )  THEN
-!AH          yce = yce + yexn
-!AH       ENDIF
-!AH       DO  j = cg%ny, 0, -1
-!AH          IF ( cg%coord_y(j) < yce )  THEN
-!AH             jcn = MIN( cg%ny + nbgp, j+1 )
-!AH             EXIT
-!AH          ENDIF
-!AH       ENDDO
-!AH
-!AH       coarse_bound(1) = icl
-!AH       coarse_bound(2) = icr
-!AH       coarse_bound(3) = jcs
-!AH       coarse_bound(4) = jcn
-!AH       coarse_bound(5) = myid
 !
 !--    Determine the anterpolation index limits. If at least half of the 
@@ -1578,5 +1401,4 @@
 !--    anterpolation domain, or not included at all if we are at the outer 
 !--    edge of the child domain.
-
 !
 !--    Left
